#include <stdio.h>

#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <deque>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <iterator>
#include <list>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <sstream>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>
//#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define pb push_back
#define mp make_pair
#define f first
#define s second
#define ld long double
#define PI 3.14159265

const ll maxn = 1e6 + 1, maxm = 1e6 + 1;
const ll mod = 1e9 + 7, inf = 1e9, block = 550, hb = 7, base = 1000050017,
         biginf = 5e18;
const ld eps = 1e-9;


int n = 10, m = 10;
char a[100][100];
int used[100][100];
int dx[] = {0, 0, 1, -1, 1, 1, -1, -1};
int dy[] = {1, -1, 0, 0, -1, 1, 1, -1};
vector<pair<int, int>> pos;
bool inner(int x, int y){
    return (x >= 1 && x <= 10 && y >= 1 && y <= 10);
}
void dfs(int x, int y){
    pos.pb(mp(x, y));
    used[x][y] = 1;
    for (int i = 0; i < 8; ++i){
        int nx = x + dx[i], ny = y + dy[i];
        if (inner(nx, ny) && used[nx][ny] == 0 && a[nx][ny] == '#'){
            dfs(nx, ny);
        }
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    for (int i = 1; i <= n; ++i){
        for (int j = 1; j <= m; ++j){
            cin >> a[i][j];
        }
    }
    vector<int> kek = {4, 3, 3, 2, 2, 2, 1, 1, 1, 1};
    int cur = 0;
    while (cur < (int)kek.size()){
        for (int i = 1; i <= n; ++i){
            for (int j = 1; j <= m; ++j){
                used[i][j] = 0;
            }
        }
        vector<pair<int, int>> mx;
        for (int i = 1; i <= n; ++i){
            for (int j = 1; j <= m; ++j){
                if (a[i][j] == '#'){
                    pos.clear();
                    dfs(i, j);
                    if ((int)pos.size() > (int)mx.size()){
                        mx = pos;
                    }
                }
            }
        }
      //  cout << "lol\n";
        if (kek[cur] == (int)mx.size()){
            cur += 1;
            for (auto it : mx){
                a[it.f][it.s] = '.';
            }
            if ((int)mx.size() == 1){
                continue;
            }
            set<int> setik, setik2;
            for (auto it : mx){
                setik.insert(it.f);
                setik2.insert(it.s);
            }
            if ((int)setik.size() > 1 && (int)setik2.size() > 1){
                cout << "NO\n";
                exit(0);
            }
        }
        else{
            cout << "NO\n";
            exit(0);
        }
    }
    for (int i = 1; i <= n; ++i){
        for (int j = 1; j <= m; ++j){
            if (a[i][j] == '#'){
                cout << "NO\n";
                exit(0);
            }
        }
    }
    cout << "YES\n";
}
