#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
template<class T> istream& operator>>(istream& is, vector<T>& arr) { for(auto& i:arr) is>>i; return is;}
template<class T> ostream& operator<<(ostream& os, vector<T>& arr) { for(auto& i:arr) os<<i<<" "; return os;}
struct Event{
    int d, type, w, num;
    Event(){}
    Event(int d, int type, int w, int num):d(d), type(type), w(w), num(num){}
};
inline bool operator <(const Event& a, const Event& b){
    return make_pair(a.d, a.type) < make_pair(b.d, b.type);
}
inline ld bin_pow(ld n, int pow){
    if(pow == 0){
        return 1;
    }
    if(pow == 1){
        return n;
    }
    if(pow % 2 == 0){
        return bin_pow(n * n, pow / 2);
    }
    else{
        return n * bin_pow(n, pow - 1);
    }
}
ll rec(ll w,ll h){
ll s = w*h;
if(w<h) swap(w,h);
if(w==1) return s;
return s+rec(w/2,h)+rec(w-w/2,h);
}
/// 2^log(w) = w

vector<string> f(10);

vector<int> cs;
int qc=0;

void dfs(int x,int y,int col){
if(x<0||x==10||y<0||y>10)return;
if(f[x][y]!='#')return;
f[x][y]=col;
cs.back()++;
dfs(x-1,y,col);
dfs(x+1,y,col);
dfs(x,y+1,col);
dfs(x,y-1,col);
}
signed main()
{
ios_base::sync_with_stdio(0);
cin.tie(0);
cout.precision(30);
int n, m;
cin >> n >> m;
ld r;
cin >> r;
vector<Event>ev;
vector<ld>ans(m);
for(int i = 0;i < n;i++)
{
    int d, w;
    cin >> d >> w;
    ev.push_back(Event(d, 0, w, -1));
}
for(int i = 0;i < m;i++){
    int d;
    cin >> d;
    ev.push_back(Event(d, 1, -1, i));
}
sort(all(ev));
ld x = 0;
int d_pref = ev[0].d;
for(auto& e:ev){
    if(e.type == 0){
        x = x * bin_pow(1 - r, e.d - d_pref) + r * e.w;
    } else{
        x = x * bin_pow(1 - r, e.d - d_pref);
        ans[e.num] = x;
    }
    d_pref = e.d;
}
for(auto el:ans){
    cout << el << ' ';
}
return 0;
}
