#include <map>
#include <set>
#include <list>
#include <cmath>
#include <ctime>
#include <deque>
#include <queue>
#include <stack>
#include <string>
#include <bitset>
#include <cstdio>
#include <limits>
#include <vector>
#include <climits>
#include <cstring>
#include <cstdlib>
#include <fstream>
#include <numeric>
#include <sstream>
#include <cassert>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <fstream>
#include <unordered_map>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(),x.end()
#define pb push_back
#define ent "\n"

const int maxn = (int)1e6 + 13;
const ll inf = (long long)1e18 + 20;
const int mod = (int)1e9 + 7;
string res[maxn];
string plu(string a,string b){
    string ans = "";
    int u = 0;
    if(a.size() < b.size())swap(a,b);
    for(int i = 1;i <= a.size();i++){
        int g = u;
        if(i <= b.size()){
            g += (b[b.size() - i] - '0');
        }
        g += (a[a.size() - i] - '0');
        ans += char((g % 10) + '0');
        u = (g / 10);
    }
    if(u > 0)ans += '1';
    reverse(all(ans));
    return ans;
}
string get(ll x,ll y){
    if(x == 1 || y == 1){
        return res[max(x,y)];
    }
    else{
        string ans ="";
        if(x >= y){
            ans = plu(get(x - 1,y),get(1,y));
        }
        else{
            ans = plu(get(x,y - 1),get(x,1));
        }
        string g = to_string(x * y);
        return plu(ans,g);
    }
}
void solve(){
    res[1] = "1";
    ll h,w;cin >> h >> w;
    for(ll i = 2;i <= max(h,w);i++){
        string g = to_string(i + 1);
        res[i] = plu(res[i - 1],g);
    }
    queue <pair<int,int> > q;
    q.push({h,w});
    string ans = "0";
    while(!q.empty()){
        pair<int,int> u = q.front();
        q.pop();
        ll x= u.first,y = u.second;
        if(x == 1 || y == 1){
            ans= plu(ans,res[max(x,y)]);
        }
        else if(x > y){
            string g = to_string(x * y);
            ans = plu(ans,res[y]);
            ans = plu(ans,g);
            q.push({x-1,y});
        }
        else{
            string g = to_string(x * y);
            ans = plu(ans,g);
            ans = plu(ans,res[x]);
            q.push({x,y - 1});
        }
    }
    cout << ans;
}

int main(){
 ios_base::sync_with_stdio(0);
 cin.tie(0);
 int t = 1;
 //cin >> t;
 while(t --){
  solve();
 }
 return 0;
}
