# Считываем входные данные
field = [input() for _ in range(10)]

# Проверяем корректность расстановки кораблей
def check_ships(field):
    ship_counts = [0, 4, 3, 2, 1]  # Количество кораблей каждого размера
    
    def check_ship(i, j, size):
        for x in range(i, i + size):
            for y in range(j, j + size):
                if x >= 10 or y >= 10 or field[x][y] != '#':
                    return False
        return True
    
    for i in range(10):
        for j in range(10):
            if field[i][j] == '#':
                # Проверяем 4-палубный корабль
                if check_ship(i, j, 4):
                    ship_counts[4] -= 1
                # Проверяем 3-палубные корабли
                elif check_ship(i, j, 3):
                    ship_counts[3] -= 1
                # Проверяем 2-палубные корабли
                elif check_ship(i, j, 2):
                    ship_counts[2] -= 1
                # Проверяем 1-палубные корабли
                elif check_ship(i, j, 1):
                    ship_counts[1] -= 1
    
    # Если все корабли расставлены верно, то все элементы в ship_counts должны быть равны нулю
    return "YES" if all(count == 0 for count in ship_counts) else "NO"

# Выводим результат
print(check_ships(field))
