def is_valid_battleship_placement(field):
    ship_counts = {
        'Battleship': 0,
        'Cruisers': 0,
        'Destroyers': 0,
        'Submarines': 0
    }
    
    for i in range(10):
        for j in range(10):
            if field[i][j] == '#':
               if (i > 0 and field[i - 1][j] == '#') or (j > 0 and field[i][j - 1] == '#'):
                    return "NO" 
               if i < 9 and field[i + 1][j] == '+' and (i < 8 and field[i + 2][j] == '#'):
                    return "NO"  
               if j < 9 and field[i][j + 1] == '+' and (j < 8 and field[i][j + 2] == '#'):
                    return "NO"  
               if i < 9 and field[i + 1][j] == '#':
                    ship_counts['Cruisers'] += 1
                    if ship_counts['Cruisers'] > 2:
                        return "NO"  
               elif j < 9 and field[i][j + 1] == '#':
                    ship_counts['Cruisers'] += 1
                    if ship_counts['Cruisers'] > 2:
                        return "NO"  
               elif i < 9 and field[i + 1][j] == '#' and i < 8 and field[i + 2][j] == '#':
                    ship_counts['Battleship'] += 1
                    if ship_counts['Battleship'] > 1:
                        return "NO"  
               elif j < 9 and field[i][j + 1] == '#' and j < 8 and field[i][j + 2] == '#':
                    ship_counts['Battleship'] += 1
                    if ship_counts['Battleship'] > 1:
                        return "NO"  
               elif i < 9 and field[i + 1][j] == '#':
                    ship_counts['Destroyers'] += 1
                    if ship_counts['Destroyers'] > 3:
                        return "NO" 
               elif j < 9 and field[i][j + 1] == '#':
                    ship_counts['Destroyers'] += 1
                    if ship_counts['Destroyers'] > 3:
                        return "NO"  
               else:
                    ship_counts['Submarines'] += 1
                    if ship_counts['Submarines'] > 4:
                        return "NO"  
    
    if (
        ship_counts['Battleship'] == 1 and
        ship_counts['Cruisers'] == 2 and
        ship_counts['Destroyers'] == 3 and
        ship_counts['Submarines'] == 4
    ):
        return "YES"
    else:
        return "NO"

field = [input() for _ in range(10)]

result = is_valid_battleship_placement(field)
print(result)

