#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <set>
#include <map>
#include <fstream>
#include <algorithm>
#include <stack>
#include <deque>
#include <iomanip>
#include <queue>
#include <sstream>


using namespace std;


#define int long long
#define ull unsigned long long

int mod = 998244353;


int fact(int n){
    int f = 1;
    for(int i = 1; i < n; i++){
        f = (f * (i + 1)) % mod;
    }
    return f;
}

void HeapSort(vector<int>& values) {
    make_heap(values.begin(), values.end());
    for (auto i = values.end(); i != values.begin(); --i) {
        pop_heap(values.begin(), i);
    }
}

int bp(int a, int m){
    if(m == 1)return a;
    if(m % 2) return (a *bp(a, m - 1));
    int t = bp(a, m / 2);
    return (t * t);
}

vector<int> er(int n, vector<int> &g){
    vector<int> val;
    int v = n;
    while(v != 1){
        if(val.empty() || val[val.size() - 1] != g[v]){
            val.push_back(g[v]);
        }
        v = v / g[v];
    }
    return val;
}


struct edg{
    int v, u, w;
};


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    long double r;
    cin >> r;
    map<int, int> a;
    set<int> f;
    for(int i = 0; i < n; i++){
        int x, y;
        cin >> x >> y;
        a[x] = y;
        f.insert(x);
    }
    vector<int> opera(m);
    map<int, int> g;
    for(int i = 0; i < m; i++){
        cin >> opera[i];
        f.insert(opera[i]);
        g[opera[i]] = 1;
    }
    long double dp = 0;
    int k = 0;
    for(auto i : f){
        if(a.count(i)){
            dp = (pow((1 - r), (i - k)) * dp) + (r * a[i]);
        }
        else{
            dp = pow((1 - r), (i - k)) * dp;
        }
        if(g[i] == 1){
            cout << fixed << setprecision(6) << dp << " ";
        }
        k = i;
    }
    return 0;
}
