#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;

const int inf = 1e9;
const ll infll = 1e18;

struct Range {
    ll l, r;
};

bool comp(Range a, Range b) {
    return (a.r - a.l > b.r - b.l);
}

struct llp {
    ll x;

    bool operator < (const llp &other) const {
        return x > other.x;
    }
};

void solve() {
    ll n;
    int k;
    cin >> n >> k;

    set<ll> p;
    set<llp> pp;
    set<Range, decltype(comp)*> s(comp);
    p.insert(0);
    p.insert(n + 1);
    s.insert({1, n});
    vector<ll> a(k);

    int cur = 0;

    while (k--) {
        char c; cin >> c;
        if (c == '+') {
            auto range = *s.begin();
            s.erase(s.begin());

            ll l = range.l, r = range.r;

            int m = l + (r - l) / 2;
            a[cur++] = m;
            p.insert(m);
            pp.insert({m});
            s.insert({l, m - 1});
            s.insert({m + 1, r});
        } else {
            int x; cin >> x, --x;
            ll m = a[x];

            auto itr = p.upper_bound(m);
            auto itl = pp.upper_bound({m});

            ll ml = itl->x;
            ll mr = *itr;

            p.erase(m);
            pp.erase({m});

            s.erase({ml + 1, m - 1});
            s.erase({m + 1, mr - 1});

            s.insert({ml + 1, mr - 1});
        }
    }

    for (int i = 0; i < cur; ++i)
        cout << a[i] << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    freopen("input.txt", "r", stdin);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}
