﻿#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <algorithm>
#include <map>
#include <deque>
#define int long long
#define double long double
using ll = long long;
using namespace std;
const int mod = 1e9 + 7;
const int INF = 1e9 + 7;
#define get_time (double)clock() / (double)(CLOCKS_PER_SEC)
#ifndef ONLINE_JUDGE
#define debug(x) cerr << (#x) << ": " << x << endl;
#else
#define debug(x)
#endif
ll max(ll a, ll b) {
    return (a > b) ? a : b;
}
ll min(ll a, ll b) {
    return (a < b) ? a : b;
}
ll bs_sqrt(ll x) {
    ll left = 0, right = 2000000123;
    while (right > left) {
        ll mid = (left + right) / 2;
        if (mid * mid > x) {
            right = mid;
            continue;
        }
        left = mid + 1;
    }
    return left - 1;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
int bin_pow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        ll t = bin_pow(a, n / 2);
        return (t * t);
    }
    else {
        ll t = bin_pow(a, n - 1);
        return (t * a);
    }
}
const int N = 10;
void br() {
    cout << "NO";
    exit(0);
}
void solve() {
    vector<vector<int> > a(N, vector<int>(N, 0)), used(N, vector<int>(N, 0));
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            char c; cin >> c;
            if (c == '#') a[i][j] = 1;
        }
    }
    int n = 10;
    for (int i = 0; i < n - 1; i++) {
        for (int j = 0; j < n; j++) {
            if (a[i][j] == 0) continue;
            if (a[i + 1][j] == 1 && j > 0 && a[i][j - 1] == 1) {
                br();
            }
            if (a[i + 1][j] == 1 && j < n - 1 && a[i][j + 1] == 1) {
                br();
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (a[i][j] == 1) {
                if (i > 0 && j > 0 && a[i - 1][j - 1] == 1) br();
                if (i > 0 && j < n - 1 && a[i - 1][j + 1] == 1) br();
            }
        }
    }
    vector<int> all(10);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            int cnt = 0;
            if (a[i][j] == 1) {
                if (i < n - 1 && a[i + 1][j] == 1) continue;
                if (i > 0 && a[i - 1][j] == 1) continue;
                while (j < n && a[i][j] == 1) {
                    used[i][j] = 1;
                    j++;
                    cnt++;
                }
               
                if (cnt > 4) br();
                all[cnt]++;
            }
        }
    }
    for (int j = 0; j < n; j++) {
        for (int i = 0; i < n; i++) {
            int cnt = 0;
            if (used[i][j]) continue;
            if (a[i][j] == 1) {
                if (j < n - 1 && a[i][j + 1] == 1) continue;
                while (i < n && a[i][j] == 1) {
                    used[i][j] = 1;
                    i++;
                    cnt++;
                }
                if (cnt > 4) br();
                all[cnt]++;
            }
        }
    }
    for (auto c : all) cout << c << " ";
    if (all[1] != 4 || all[2] != 3 || all[3] != 2 || all[4] != 1) br();
    cout << "YES";
}
signed main() {
    /*
    #ifdef ONLINE_JUDGE 
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);
    #endif
    */
    cout << fixed << setprecision(20);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}