import sys
def calculate_minimum_lanterns(n, m, k):
    # Рассчитываем количество фонарей для длины и ширины площади
    lanterns_n = n // k
    lanterns_m = m // k

    # Если длина или ширина не делится нацело на длину стороны квадрата, добавляем один фонарь
    if n % k != 0:
        lanterns_n += 1
    if m % k != 0:
        lanterns_m += 1

    # Общее количество фонарей необходимых для освещения площади
    total_lanterns = lanterns_n * lanterns_m

    return total_lanterns

# Ввод данных
n, m, k = map(int, input().split())

# Вызываем функцию и выводим результат
result = calculate_minimum_lanterns(n, m, k)
print(result)
sys.stdout.flush()
