# Функция для расчета отходов
def calculate_waste(r, production_days, query_days):
    waste = 0
    production_dict = {day: raw for day, raw in production_days}

    for day in range(1, max(query_days) + 1):
        waste *= (1 - r)
        if day in production_dict:
            waste += production_dict[day] * r
        if day in query_days:
            print(f"Day {day}: {waste:.6f}")

# Интерактивный ввод данных пользователем
r = float(input("Введите коэффициент уменьшения отходов (r): "))

num_production_days = int(input("Введите количество дней производства: "))
production_days = []
for _ in range(num_production_days):
    day, raw = map(int, input("Введите день производства и количество сырья, через пробел: ").split())
    production_days.append((day, raw))

num_query_days = int(input("Введите количество дней для запроса: "))
query_days = []
for _ in range(num_query_days):
    query_days.append(int(input("Введите день для запроса: ")))

# Вызов функции для расчета и вывода отходов
calculate_waste(r, production_days, query_days)
