#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()

const int maxn = 10 + 5;
const int mod = 1e9 + 7;

int dx[] = {0,0,-1,1};
int dy[] = {-1,1,0,0};

int hx[] = {0,0,-1,1,1,-1,1,-1};
int hy[] = {-1,1,0,0,-1,1,1,-1};

int used[maxn][maxn], lol[maxn][maxn];
char a[maxn][maxn];
bool f = 1;
int n = 10, m = 10, cnt = 0;

void dfs(int x, int y, int tp, int fx, int fy, int kor) {
  used[x][y] = kor;
  cnt++;
  for (int i = 0; i < 4; i++) {
    int nx = x + dx[i];
    int ny = y + dy[i];
    if (nx < 1 || nx > n || ny < 1 || ny > m) continue;
    if (a[nx][ny] == '.') continue;
    if (nx == fx && ny == fy) continue;
    if (tp == -1) {
      dfs(nx, ny, i, x, y, kor);
    } else {
      if (tp != i) {
        cout << "NO\n";
        exit(0);
      } else {
        dfs(nx, ny, i, x, y, kor);
      }
    }
  }
}

void check(int x, int y, int fx, int fy) {
  lol[x][y] = 1;
  for (int i = 0; i < 8; i++) {
    int nx = x + hx[i];
    int ny = y + hy[i];
    if (nx < 1 || nx > n || ny < 1 || ny > m) continue;
    if (a[nx][ny] == '.') continue;
    if (nx == fx && ny == fy) continue;
    if (used[x][y] != used[nx][ny]) {
      cout << "NO\n";
      exit(0);
    }
    check(nx, ny, x, y);
  }
}

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0); cout.tie(0);
  
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= m; j++) {
      cin >> a[i][j];
    }
  }
  int kor = 0;
  map <int, int> mp;
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= m; j++) {
      if (a[i][j] == '#' && !used[i][j]) {
        kor++;
        dfs(i, j, -1, -1, -1, kor);
        mp[cnt]++;
        cnt = 0;
      }
    }
  }
  if (kor != 10) {
    cout << "NO\n";
    exit(0);
  }
  if (mp[4] != 1 || mp[3] != 2 || mp[2] != 3 || mp[1] != 4) {
    cout << "NO\n";
    exit(0);
  }
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= m; j++) {
      if (a[i][j] == '#' && !lol[i][j]) {
        check(i, j, -1, -1);
      }
    }
  }
  cout << "YES\n";
}
