def is_valid_battleship_board(board):
    # Проверка, что на поле 10x10 есть 10 кораблей
    counts = [0, 0, 0, 0, 0]  # Четырехпалубник, трехпалубник, двухпалубник, однопалубник, пустая клетка

    for i in range(10):
        for j in range(10):
            if board[i][j] == '#':
                # Проверка, что корабль целиком помещается внутрь поля
                if i < 10 and j < 7 and all(board[i][j + k] == '#' for k in range(4)):
                    counts[0] += 1
                elif i < 10 and j < 8 and all(board[i][j + k] == '#' for k in range(3)):
                    counts[1] += 1
                elif i < 10 and j < 9 and all(board[i][j + k] == '#' for k in range(2)):
                    counts[2] += 1
                elif i < 10 and j < 10:
                    counts[3] += 1
                else:
                    return False
            elif board[i][j] == '.':
                counts[4] += 1
            else:
                return False

    return counts == [1, 2, 3, 4, 90]  # Проверка, что есть ровно по одному кораблю каждого типа

# Пример использования функции
board = list(input())

if is_valid_battleship_board(board):
    print("YES")
else:
    print("NO")
