from collections import deque

n, k = map(int, input().split())
free_seats = deque(range(1, n + 1))
occupied_seats = deque()

for _ in range(k):
    query = input()
    if query == "+":
        seat = free_seats.popleft()
        if not occupied_seats:
            distance = n
        else:
            distance = (occupied_seats[-1] - occupied_seats[0]) // 2
        occupied_seats.append(seat)
        print(seat)
    else:
        free_seat = int(query[1:])
        free_seats.append(free_seat)
        occupied_seats.remove(free_seat)
