n, m, k = map(int, input().split())

# Список смежности для исходного графа
graph = [[] for _ in range(n)]

# Списки ребер для исходного и получившегося графов
edges_orig = set()
edges_new = set()

# Заполняем списки ребер и список смежности
for i in range(m):
    u, v = map(int, input().split())
    edges_orig.add((u, v))
    edges_orig.add((v, u))
    graph[u - 1].append(v)
    graph[v - 1].append(u)

for i in range(k):
    u, v = map(int, input().split())
    edges_new.add((u, v))
    edges_new.add((v, u))

actions = []  # Список действий Паши

for u, v in edges_new:
    if (u, v) in edges_orig:
        edges_orig.remove((u, v))
        edges_orig.remove((v, u))
    else:
        # Проверяем, можно ли восстановить это ребро из оставшихся ребер
        found = False
        for w in graph[u - 1]:
            if (v, w) in edges_orig or (w, v) in edges_orig:
                actions.append((u, v, w))
                edges_orig.remove((v, w))
                edges_orig.remove((w, v))
                found = True
                break
        if not found:
            print("NO")
            exit()

print("YES")
print(len(actions))
for action in actions:
    print(*action)
