#include <iostream>
#include <vector>
#include <unordered_map>

using namespace std;

int n, m;
float r;
vector<int> vec;
unordered_map<int, int> map;

float f(int day) {
    if (day == 0) {
        return 0;
    } else {
        if (map.count(day)) {
            return f(day - 1) * (1 - r) + map[day] * r;
        } else {
            return f(day - 1) * (1 - r);
        }
    }
}

void setList() {
    while (m > 0) {
        m--;
        int d;
        cin >> d;
        vec.push_back(d);
    }
}

void setMap() {
    while (n > 0) {
        n--;
        int d, w;
        cin >> d >> w;
        map[d] = w;
    }
}

void setN() {
    cin >> n;
}

void setM() {
    cin >> m;
}

void setR() {
    cin >> r;
}

int main() {
    setN();
    setM();
    setR();
    setMap();
    setList();
    for (int i : vec) {
        cout << f(i) << " ";
    }
    return 0;
}