#include <bits/stdc++.h>
#define ll long long
#define ff irst
#define ss second
#define pb push_back
#define mp make_pair

using namespace std;

vector<vector<char> > p1, p2, p3, p4;
vector<vector<char> > c(20, vector<char>(20, '.'));
vector<int> a, b;

void update(int i, int j, int n, int m) {
    for (int i1 = i; i1 < n + i && i1 < c.size(); i1++) {
        for (int j1 = j; j1 < m + j && j1 < c.size(); j1++) {
            c[i1][j1] = '.';
        }
    }
}

int check(vector<vector<char> >& p, int i, int j) {
    i--;
    j--;
    bool ok = 1;
    for (int i1 = 0; i1 < p.size(); i1++) {
         for (int j1 = 0; j1 < p[i1].size(); j1++) {
            if (p[i1][j1] != c[i1 + i][j1 + j]) {
                ok = 0;
            }
         }
    }
    if (ok) {
        update(i, j, p.size(), p[0].size());
        return 1;
    }
    ok = 1;
    for (int j1 = 0; j1 < p[0].size(); j1++) {
        for (int i1 = 0; i1 < p.size(); i1++) {
            if (p[i1][j1] != c[j1 + i][i1 + j]) {
                ok = 0;
            }
        }
    }
    if (ok) {
        update(i, j, p[0].size(), p.size());
        return 1;
    }
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    p1 = {{'.', '.', '.'},
          {'.', '#', '.'},
          {'.', '.', '.'}};

    p2 = {{'.', '.', '.', '.'},
          {'.', '#', '#', '.'},
          {'.', '.', '.', '.'}};

    p3 = {{'.', '.', '.', '.', '.'},
          {'.', '#', '#', '#', '.'},
          {'.', '.', '.', '.', '.'}};

    p4 = {{'.', '.', '.', '.', '.', '.'},
          {'.', '#', '#', '#', '#', '.'},
          {'.', '.', '.', '.', '.', '.'}};
    a.resize(5);
    b = {0, 4, 3, 2, 1};
    for (int i = 1 ; i <= 10; i++) {
        for (int j = 1; j <= 10; j++) {
            cin >> c[i][j];
        }
    }
    for (int i = 1; i < 11; i++) {
        for (int j = 1; j < 11; j++) {
            if (c[i][j] == '#') {
                if (check(p1, i, j)) {
                    a[1]++;
                } else if (check(p2, i, j)) {
                    a[2]++;
                } else if (check(p3, i, j)) {
                    a[3]++;
                } else if (check(p4, i, j)) {
                    a[4]++;
                } else {
                    cout << "NO" << endl;
                    return 0;
                }
            }
        }
    }
    if (a != b) {
        cout << "NO" << endl;
    }
    cout << "YES" << endl;
    return 0;
}
