#include <bits/stdc++.h>
using namespace std;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int, int>;
using ll = long long;
using vll = vector<ll>;
using pll = pair<ll, ll>;
using ld = long double;
using ull = unsigned long long;
#define pb  push_back
#define pf  push_front
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define x first
#define y second
const ll mod = 1e9 + 7;
const int N = 1e5;
const ll INF = 1e18;
int sz = 1;
struct segtree{
	vector<pair<ll, ll>> tree;
	void init(int n){
		while(sz < n){
			sz *= 2;
		}
		tree = vector<pll>(2*sz-1, {0, 0});
	}
	void set(int i, pll val, ll x = 0, ll lx = 0, ll rx = sz){
		if(rx - lx == 1){
			tree[x] = val;
			return;
		}
		ll m = (lx + rx)/2;
		if(i < m){
			set(i, val, 2*x+1, lx, m);
		}
		else{
			set(i, val, 2*x+2, m, rx);
		}
		tree[x] = max(tree[2*x+1], tree[2*x+2]);
 	}
 	pll get(int l, int r, ll x = 0, ll lx = 0, ll rx = sz){
 		if(lx >= r || rx <= l){
 			return {0, 0};
 		}
 		if(lx >= l && rx <= r){
 			return tree[x];
 		}
 		ll m = (lx + rx)/2;
 		return max(
 		get(l, r, 2*x+1, lx, m), 
 		get(l, r, 2*x+2, m, rx)
 		);
 	}
};

int main(){
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int n; cin >> n;
	vll h(n);
	vll c(n);
	segtree st;
	st.init(n);
	for(int i = 0; i < n; i++){
		cin >> h[i];
		st.set(i, {h[i], i});
	}
	for(int i = 0; i < n; i++){
		cin >> c[i];
	}
	ll ans = 0;
	ll l = 0;
	ll r = n;
	while(r != l){
		//cout << l << " " << r << '\n';
		pll mx = st.get(l, r);
		ans += c[mx.y];
		int id = mx.y;
		pll mx1 = st.get(id, r);
		pll mx2 = st.get(l, id+1);
		if(c[mx1.y] <= c[mx2.y]){
			r = id;
		}
		else{
			l = id;
		}
	}
	cout << ans << '\n';
	return 0;
}