#include <bits/stdc++.h>
#pragma GCC optimize(O3)

using namespace std;

unordered_map <int, long double> cache;
unordered_map<int, long double> U;
unordered_set <int> s;

long double r;

long double S(unsigned int n) {
    //if (n == 1) return U[1]*r;
    //return S(n-1)*((long double)1-r)+U[n]*r;
    if(cache.find(n) != cache.end())
        return cache[n];
    long double prev = U[1]*r;
    for (int i = 2; i <= n; i++) {
        int u;
        auto it = U.find(i);
        if (it == U.end()) u = 0;
        else u = it->second;
        prev = prev * ((long double)1-r)+u*r;
        if (s.find(i) != s.end())
            cache[i] = prev;
    }
    return prev;
}

int main () { cout.tie(0);
    ios::sync_with_stdio(false); cin.tie(0);
    int n, m;
    cin >> n >> m;
    cin >> r;
    while (n--) {
        int d, w;
        cin >> d >> w;
        U[d] = w;
    }
    cout.precision(7);
    vector <int> req(m);
    for (int i = 0; i < m; i++) {
        cin >> req[i];
        s.insert(i);
    }
    for (auto elem : req) {
        cout << S(elem) << " ";
    }
    cout << endl;
}
