#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair < ll, ll >;

bool cmp(pii a, pii b) {
    return a.first > b.first || (a.first == b.first && a.second < b.second);
}

int main() {
    cin.tie(0); ios_base::sync_with_stdio(0);
    
    ll n, k; char op; int j; cin >> n >> k;

    ll pos[k + 1];

    set < pii, decltype(&cmp) > s1(cmp);
    set < pii > s2;

    int cnt = 0, id = 0;

    for (int i = 1; i <= k; i++) {
        cin >> op;

        if (op == '+') {
            cnt++, id++;

            if (cnt == 1) {
                pos[id] = 1;
                cout << 1 << "\n";

                continue;
            } else if (cnt == 2) {
                pos[id] = n;
                cout << n << "\n";

                s1.insert({ n, 1 });
                s2.insert({ 1, n });

                continue;
            }

            auto [len, l] = *s1.begin();

            int r = l + len - 1;
            int m = (l + r) / 2;

            pos[id] = m;
            cout << m << "\n";

            s1.erase({ len, l });
            s2.erase({ l, r });
            s1.insert({ m - l + 1, l });
            s1.insert({ r - m + 1, m });
            s2.insert({ l, m });
            s2.insert({ m, r });
        } else {
            cin >> j; cnt--;

            if (cnt == 0) {
                continue;
            } else if (cnt == 1) {
                s1.clear(), s2.clear();
                continue;
            }

            auto [l1, r1] = *(--s2.lower_bound({ pos[j], -1 }));
            auto [l2, r2] = *s2.lower_bound({ pos[j], -1 });

            s2.erase({ l1, r1 });
            s2.erase({ l2, r2 });
            s1.erase({ r1 - l1 + 1, l1 });
            s1.erase({ r2 - l2 + 1, l2 });
            s2.insert({ l1, r2 });
            s1.insert({ r2 - l1 + 1, l1 });
        }
    }
}
