//coded by seeyou
/* @@@@@@@@@@@@@@@@@@@@@@*+++*====*+:::++*===**++:::::::::::::+*@@@@@#####@@@@@@
 @@@@@@@@@@@@@@@@@@@@#+**++*+::::::+==+:::::::::::+****++::::+++#@######@@@@@@@@
 @@@@@@@@@@@@@@@@##@***+++::::+++**+::::::::::+=*++::+++++++:::+:=@=**#@@@@@@@@@
 @@@@@@@@@@@@@@@##=+:--------------------+==#======*+:::::::++::+:=+++:+@@@@@@@@
 @@@@@@@@@@@@@#::+*===*****----:::::::++::::*:+++**=====*+:::::+:+:==*+::*@@@@@@
 @@@@@@@@@@@@#+++==:-.--:+*---:::::+++*=::::*::::::::::+*===+::::+++==*+::+@@@@@
 @@@@@@@@@@#..-.+=:.--:::++---::::+++++++++:*===*++:::::::::+=*:::++===++::+@@@@
 @@@@@@@@@#*--:-++::*====++:::+:++++++++++++*+::++++++++::::::::+::+*#==++:+@#@@
 @@@@@@@@@@:::::*=+=######=*::+=#=++:::+++++**+:::::::::::+++:::::+++#==*+:+@#@@
 @@@@@@@@@@*##=+*##########*::+++++**=*=++++======*+:::::::::::++:::*#===+++@##@
 @@@@@@@@@@@####*###@#####+:::++++++*+****=::++*=========*+++++**++++#===*++@###
 @@@@@@@@@@@@##+=########=+:::++***==#=**++*==*++::+*====+++*====*===@===*:+@##@
 @@@@@@@@@@@#***=#########=====**+++++++++++*==++==*+:::+*==*:::::+*=#====::@##@
 @@@@@@@@@@@@@######=**+++++++=####*++*####+=*+**+:+====*+:::+**+::::#====::##@@
 @@@@@@@@@@@@@@==*++++++=##***#####**+######=#**=====**======*+:::::=====*+:#@@@
 @@@@@@@@@@@@@@@@#=++++##@@@@W##@#****=###*:*=++======#===#=========#====*::=@@@
 @@@@@@@@@@@@@@#=@W#++++#@W@==@WWWW@@@@@@=**=#=**===*+++**+*=======@====*+::=@@@
 @@@@@@@@@@@@@#=**#@*+++***=#*+=#@@@@#==**==:+**+*#+++*===++======#@==*=++::=@@@
 @@@@@@@@@@@@@@=++*+++++*+=**+::++++*#=++++*==*+**+++++**+++======@@==*=:++:=#@@
 @@@@@@@@@@@@@@=*++++++++*=##++++++++=####++===++++++=====++=====@@#==**+:=:=##@
 @@@@@@@@@@@@@@*++++++++*####=++##+++#####++==**+++++*==*++*===#@@@#==*++*#:##@@
 @@@@@@@@@@@@@#++++++++++=###*++++++++***+++:+**+++****+++*====#@@@#=**::@#+##@@
 @@@@@@@@@@@@@@@*#*++++++++++++++++++++++++*#=***++++:++=#=====@@@@@=*+:=@#*@@@@
 @@@@@@@@@@@@@@@#+=*++++++++++++++++++++++++**=+++++*=###====#@@@@@@=++=@@==@@@@
 @@@@@@@@@@@@@@:*=**++++++++++++++++++++++++##==@#=##====##==@#@@@@@#+#@@@=@@@@@
 @@@@@@@@@@@@@@@*=*+#@===*****=*++++++++++++:**=#==+++++*=###@@@@@###*#@@@#@@@@@
 @@@@@@@@@@@@@@#*=@++++++***+++++++++++++++*#####*+++++++++=#@W@W@@@@==@@@@@@@@@
 @@@@@@@@@@@@@@++**@*+====*+++++++++++++++=###=*++*=##=*+++++++++#@@@@*@@@@@@@@@
 @@@@@@@@@@@@@@#+=@@@+++++++++++++++++*==#:+*==*+++++++++++++++++=@@@@@#@@@@@@@@
 @@@@@@@@@@@@@@@#=@@@=++++++++++++==#####==#=**+++++++++*=##@@@@@@W@@@@@@@@@@@@@
 @@@@@@@@@@@@@@=***@@@@=****=#@W@###===##**==+++*=#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 @@@@@@@@@@@@@@@##@@@@@@@@@@@@######==#*+*#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 W@@@@@@@@@@@@@@#=@@@@@@@@W#########@W@####@@@@@@@@@@@@@@@@@@@@@@@WW@@@@@@@@@@@@
 WW@@@@@@@@@@@@====@@@@@@@@###@WWWWW@@==@@@@@@@@@@@@@@@@@@@@@@@WWWWW@@@W@@@@@@@@
 WWWW@@@@@@@@@@@#@@@@@@@@@@WWWWWWW@**=@@@@@@@@@@@@@@@@@@@@WWWWWWWWW@@W@@@@@@@@@@
 WWWWWWWW@@@@@@@==@@@@WW@@@@@WWWW#=#@@WWWWWWWWWWWWWWWWWWWWWWW@@@@@@@@WW@@@W@@@@W
 WWWWWWWW@@@@@@@###@WW@@@@@@@@@@@@@@@@@@@@WWWWWWWWWWWWWWWWWWWWWWWWWWWW@@@@WW@@@@
 WWWWWWWWW@@@@@@##@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@W@@@
 WWWWWWWWW@WWW@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 WWWW@#=====****************=##@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 */
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <unordered_map>

using namespace std;

#define all(x) x.begin(), x.end()
#define ll long long
#define en endl;


void solve () {
    int n, m;
    cin >> n >> m;
    
    unordered_map<int, int> count_map;
    vector<int> c;
    
    for (int i = 0; i < m; i++) {
        int num;
        cin >> num;
        c.push_back(num);
        count_map[num]++;
    }
    
    unordered_map<int, int> result_map;
    
    for (int i = 0; i < m; i++) {
        if (count_map[c[i]] == n || count_map[c[i]] == n + 1) {
            result_map[c[i]] = 1;
        }
    }
    
    vector<int> result;
    
    for (int i = 0; i < m; i++) {
        if (result_map.find(c[i]) != result_map.end() && result_map[c[i]] == 1) {
            result.push_back(c[i]);
            result_map[c[i]] = 0;
        }
    }
    vector<int> unique_result;
    for (int num : result) {
        if (count(result.begin(), result.end(), num) == 1) {
            unique_result.push_back(num);
        }
    }
    
    cout << unique_result.size() << endl;
    
    for (int i = 0; i < unique_result.size(); i++) {
        cout << unique_result[i];
        if (i < unique_result.size() - 1) {
            cout << " ";
        }
    }
}
int main () {
        solve();
    }
