//coded by seeyou
/* @@@@@@@@@@@@@@@@@@@@@@*+++*====*+:::++*===**++:::::::::::::+*@@@@@#####@@@@@@
 @@@@@@@@@@@@@@@@@@@@#+**++*+::::::+==+:::::::::::+****++::::+++#@######@@@@@@@@
 @@@@@@@@@@@@@@@@##@***+++::::+++**+::::::::::+=*++::+++++++:::+:=@=**#@@@@@@@@@
 @@@@@@@@@@@@@@@##=+:--------------------+==#======*+:::::::++::+:=+++:+@@@@@@@@
 @@@@@@@@@@@@@#::+*===*****----:::::::++::::*:+++**=====*+:::::+:+:==*+::*@@@@@@
 @@@@@@@@@@@@#+++==:-.--:+*---:::::+++*=::::*::::::::::+*===+::::+++==*+::+@@@@@
 @@@@@@@@@@#..-.+=:.--:::++---::::+++++++++:*===*++:::::::::+=*:::++===++::+@@@@
 @@@@@@@@@#*--:-++::*====++:::+:++++++++++++*+::++++++++::::::::+::+*#==++:+@#@@
 @@@@@@@@@@:::::*=+=######=*::+=#=++:::+++++**+:::::::::::+++:::::+++#==*+:+@#@@
 @@@@@@@@@@*##=+*##########*::+++++**=*=++++======*+:::::::::::++:::*#===+++@##@
 @@@@@@@@@@@####*###@#####+:::++++++*+****=::++*=========*+++++**++++#===*++@###
 @@@@@@@@@@@@##+=########=+:::++***==#=**++*==*++::+*====+++*====*===@===*:+@##@
 @@@@@@@@@@@#***=#########=====**+++++++++++*==++==*+:::+*==*:::::+*=#====::@##@
 @@@@@@@@@@@@@######=**+++++++=####*++*####+=*+**+:+====*+:::+**+::::#====::##@@
 @@@@@@@@@@@@@@==*++++++=##***#####**+######=#**=====**======*+:::::=====*+:#@@@
 @@@@@@@@@@@@@@@@#=++++##@@@@W##@#****=###*:*=++======#===#=========#====*::=@@@
 @@@@@@@@@@@@@@#=@W#++++#@W@==@WWWW@@@@@@=**=#=**===*+++**+*=======@====*+::=@@@
 @@@@@@@@@@@@@#=**#@*+++***=#*+=#@@@@#==**==:+**+*#+++*===++======#@==*=++::=@@@
 @@@@@@@@@@@@@@=++*+++++*+=**+::++++*#=++++*==*+**+++++**+++======@@==*=:++:=#@@
 @@@@@@@@@@@@@@=*++++++++*=##++++++++=####++===++++++=====++=====@@#==**+:=:=##@
 @@@@@@@@@@@@@@*++++++++*####=++##+++#####++==**+++++*==*++*===#@@@#==*++*#:##@@
 @@@@@@@@@@@@@#++++++++++=###*++++++++***+++:+**+++****+++*====#@@@#=**::@#+##@@
 @@@@@@@@@@@@@@@*#*++++++++++++++++++++++++*#=***++++:++=#=====@@@@@=*+:=@#*@@@@
 @@@@@@@@@@@@@@@#+=*++++++++++++++++++++++++**=+++++*=###====#@@@@@@=++=@@==@@@@
 @@@@@@@@@@@@@@:*=**++++++++++++++++++++++++##==@#=##====##==@#@@@@@#+#@@@=@@@@@
 @@@@@@@@@@@@@@@*=*+#@===*****=*++++++++++++:**=#==+++++*=###@@@@@###*#@@@#@@@@@
 @@@@@@@@@@@@@@#*=@++++++***+++++++++++++++*#####*+++++++++=#@W@W@@@@==@@@@@@@@@
 @@@@@@@@@@@@@@++**@*+====*+++++++++++++++=###=*++*=##=*+++++++++#@@@@*@@@@@@@@@
 @@@@@@@@@@@@@@#+=@@@+++++++++++++++++*==#:+*==*+++++++++++++++++=@@@@@#@@@@@@@@
 @@@@@@@@@@@@@@@#=@@@=++++++++++++==#####==#=**+++++++++*=##@@@@@@W@@@@@@@@@@@@@
 @@@@@@@@@@@@@@=***@@@@=****=#@W@###===##**==+++*=#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 @@@@@@@@@@@@@@@##@@@@@@@@@@@@######==#*+*#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 W@@@@@@@@@@@@@@#=@@@@@@@@W#########@W@####@@@@@@@@@@@@@@@@@@@@@@@WW@@@@@@@@@@@@
 WW@@@@@@@@@@@@====@@@@@@@@###@WWWWW@@==@@@@@@@@@@@@@@@@@@@@@@@WWWWW@@@W@@@@@@@@
 WWWW@@@@@@@@@@@#@@@@@@@@@@WWWWWWW@**=@@@@@@@@@@@@@@@@@@@@WWWWWWWWW@@W@@@@@@@@@@
 WWWWWWWW@@@@@@@==@@@@WW@@@@@WWWW#=#@@WWWWWWWWWWWWWWWWWWWWWWW@@@@@@@@WW@@@W@@@@W
 WWWWWWWW@@@@@@@###@WW@@@@@@@@@@@@@@@@@@@@WWWWWWWWWWWWWWWWWWWWWWWWWWWW@@@@WW@@@@
 WWWWWWWWW@@@@@@##@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@W@@@
 WWWWWWWWW@WWW@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 WWWW@#=====****************=##@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 */
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <map>
#include <numeric>
#include <queue>
#include <set>

using namespace std;

#define all(x) x.begin(), x.end()
#define ll long long
#define en endl;


void solve () {
    int n;
    cin >> n;

    vector<ll> h(n);
    vector<ll> c(n);
    vector<ll> l(n, 0), r(n, 0);

    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }

    vector<int> li, ri;

    for (int i = 0; i < n; i++) {
        while (!li.empty() && h[i] > h[li.back()]) {
            li.pop_back();
        }
        if (!li.empty()) {
            l[i] = l[li.back()] + c[i];
        } else {
            l[i] = c[i];
        }
        li.push_back(i);
    }

    for (int i = n - 1; i >= 0; i--) {
        while (!ri.empty() && h[i] > h[ri.back()]) {
            ri.pop_back();
        }
        if (!ri.empty()) {
            r[i] = r[ri.back()] + c[i];
        } else {
            r[i] = c[i];
        }
        ri.push_back(i);
    }

    long long min_cost = min(l[n - 1], r[0]);

    for (int i = 0; i < n - 1; i++) {
        min_cost = min(min_cost, l[i] + r[i + 1]);
    }

    cout << min_cost << endl;
}
int main () {
        solve();
    }
