///@author: suuuiii
//#pragma GCC target("avx2")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int128 __int128
#define int long long
#define ll long long
#define ld long double
#define ve vector
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pb push_back
#define eb emplace_back
#define INF1 INT32_MAX
#define INF2 INT64_MAX
#define sz(x) (int)(x).size()


using namespace std;
using namespace __gnu_pbds;
random_device rd;
mt19937 rnd(rd());


int rand(int l, int r) {
    return l + rnd() % (r - l + 1);
}

template<typename key, typename cmp = less<key>>
using pbds = tree<key, null_type, cmp, rb_tree_tag, tree_order_statistics_node_update>;

const int Size = (1ll << 3), maxn = (int)1e5*2+1;



char a[12][12];
int used[12][12];

bool isv(int l, int r, int j) {
    if (a[l-1][j] == '#') return 0;
    if (a[r+1][j] == '#') return 0;

    for (int i = l; i <= r; ++i) {
        if (a[i][j-1] == '#' || a[i][j+1] == '#') return 0;
    }
    return 1;
}

bool isg(int l, int r, int i) {
    if (a[i][l-1] == '#') return 0;
    if (a[i][r+1] == '#') return 0;

    for (int j = l; j <= r; ++j) {
        if (a[i-1][j] == '#' || a[i+1][j] == '#') return 0;
    }
    return 1;
}

void solve() {
    for (int i = 1; i <= 10; ++i) {
        for (int j = 1; j <= 10; ++j) cin >> a[i][j];
    }

    int n = 10;

    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            if (a[i][j] == '#' && (a[i+1][j+1] == '#' || a[i+1][j-1] == '#' || a[i-1][j+1] == '#' || a[i-1][j-1] == '#')) {
                cout << "NO\n";
                return;
            }
        }
    }

    int cnt = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            if (a[i][j] != '#') continue;
            if (used[i][j]) continue;

            if (isv(i, i, j)) {
                ++cnt, used[i][j] = 1;
                continue;
            }
        }
    }

    if (cnt != 4) {
        cout << "NO\n";
        return;
    }

    cnt = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            if (a[i][j] != '#') continue;
            if (used[i][j]) continue;

            if (j+1 <= n && a[i][j+1] == '#') {

                if (isg(j, j+1, i)) {
                    ++cnt, used[i][j] = 1, used[i][j+1] = 1;
                    continue;
                }
            }

            if (j > 1 && a[i][j-1] == '#') {

                if (isg(j-1, j, i)) {
                    ++cnt, used[i][j] = 1, used[i][j-1] = 1;
                    continue;
                }
            }

            if (i > 1 && a[i-1][j] == '#') {

                if (isv(i-1, i, j)) {
                    ++cnt, used[i][j] = 1, used[i-1][j] = 1;
                    continue;
                }
            }


            if (i+1 <= n && a[i+1][j] == '#') {
                if (isv(i, i+1, j)) {
                    ++cnt, used[i][j] = 1, used[i+1][j] = 1;
                    continue;
                }
            }
        }
    }

    if (cnt != 3) {
        cout << "NO\n";
        return;
    }

    cnt = 0;

    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            if (a[i][j] != '#') continue;
            if (used[i][j]) continue;

            if (j+2 <= n && a[i][j+1] == '#' && a[i][j+2] == '#') {
                if (isg(j, j+2, i)) {
                    ++cnt, used[i][j] = 1, used[i][j+1] = 1, used[i][j+2] = 1;
                    continue;
                }
            }

            if (j > 2 && a[i][j-1] == '#' && a[i][j-2] == '#') {

                if (isg(j-2, j, i)) {
                    ++cnt, used[i][j] = 1, used[i][j-1] = 1, used[i][j-2] = 1;
                    continue;
                }
            }

            if (i > 2 && a[i-1][j] == '#' && a[i-2][j] == '#') {
                if (isv(i-2, i, j)) {
                    ++cnt, used[i][j] = 1, used[i-1][j] = 1, used[i-2][j] = 1;
                    continue;
                }
            }


            if (i+2 <= n && a[i+1][j] == '#' && a[i+2][j] == '#') {
                if (isv(i, i+2, j)) {
                    ++cnt, used[i][j] = 1, used[i+1][j] = 1, used[i+2][j] = 1;
                    continue;
                }
            }
        }
    }

    if (cnt != 2) {
        cout << "NO\n";
        return;
    }

    cnt = 0;

    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            if (a[i][j] != '#') continue;
            if (used[i][j]) continue;

            if (j+3 <= n && a[i][j+1] == '#' && a[i][j+2] == '#' && a[i][j+3] == '#') {
                if (isg(j, j+3, i)) {
                    ++cnt, used[i][j] = 1, used[i][j+1] = 1, used[i][j+2] = 1, used[i][j+3] = 1;
                    continue;
                }
            }

            if (j > 3 && a[i][j-1] == '#' && a[i][j-2] == '#' && a[i][j-3] == '#') {
                if (isg(j-3, j, i)) {
                    ++cnt, used[i][j] = 1, used[i][j-1] = 1, used[i][j-2] = 1, used[i][j-3] = 1;
                    continue;
                }
            }

            if (i > 3 && a[i-1][j] == '#' && a[i-2][j] == '#' && a[i-3][j] == '#') {
                if (isv(i-3, i, j)) {
                    ++cnt, used[i][j] = 1, used[i-1][j] = 1, used[i-2][j] = 1, used[i-3][j] = 1;
                    continue;
                }
            }


            if (i+3 <= n && a[i+1][j] == '#' && a[i+2][j] == '#' && a[i+3][j] == '#') {
                if (isv(i, i+3, j)){
                    ++cnt, used[i][j] = 1, used[i+1][j] = 1, used[i+2][j] = 1, used[i+3][j] = 1;
                    continue;
                }
            }
        }
    }

    if (cnt != 1) {
        cout << "NO\n";
        return;
    }

    cout << "YES\n";

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
//    cin >> tt;
    while (tt--){
        solve();
    }
}