#include <bits/stdc++.h>

using i64 = long long;

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n = 10;
    std::vector<std::string> a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }

    int di[] = {1, -1, 1, -1};
    int dj[] = {1, -1, -1, 1};

    auto pos = [&](int i, int j) {
        return 0 <= i && i < n && 0 <= j && j < n;
    };

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (a[i][j] != '#') continue;
            for (int k = 0; k < 4; k++) {
                int ni = i + di[k];
                int nj = j + dj[k];
                if (pos(ni, nj) && a[ni][nj] == '#') {
                    std::cout << "NO\n";
                    return 0;
                }
            }
        }
    }

    int cnt[5]{};

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            int c = 1;
            int ok = 0;
            while (j < n - 1 && a[i][j] == '#' && a[i][j + 1] == '#') {
                ok = 1;
                a[i][j] = '.';
                c++, j++;
            }
            if (c > 4) {
                std::cout << "NO\n";
                return 0;
            }
            cnt[ok * c]++;
            if (ok && j < n && a[i][j]) a[i][j] = '.';
        }
    }

    for (int j = 0; j < n; j++) {
        for (int i = 0; i < n; i++) {
            int c = 1;
            int ok = 0;
            while (i < n - 1 && a[i][j] == '#' && a[i + 1][j] == '#') {
                ok = 1;
                a[i][j] = '.';
                c++, i++;
            }
            if (c > 4) {
                std::cout << "NO\n";
                return 0;
            }
            cnt[ok * c]++;
            if (ok && i < n && a[i][j]) a[i][j] = '.';
        }
    }

    for (int i = 0; i < n; i++) {
        cnt[1] += std::count(a[i].begin(), a[i].end(), '#');
    }

    std::cout << (cnt[4] == 1 && cnt[3] == 2 && cnt[2] == 3 && cnt[1] == 4 ? "YES" : "NO") << "\n";

    return 0;
}