﻿#include <iostream>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>
#include <string>

#define ll long long
#define ld long double 

using namespace std;

int main() {
	vector <vector<char>> x(12, vector<char>(12));
	vector <vector<int>> z(12, vector<int>(12));
	for (int i = 0; i < 12; i++) {
		for (int j = 0; j < 12; j++) {
			if (i == 0 or i == 11 or j == 0 or j == 11) x[i][j] = '?';
			else cin >> x[i][j];
		}
	}

	int i = 1, j = 1;
	int x1 = 0, x2 = 0, x3 = 0, x4 = 0;
	while (j < 11) {
		if (i == 11) {
			j += 1;
			i = 1;
		}
		if (j == 11) break;
		if (x[j][i] == '.') {
			i++;
			continue;
		}
		if (x[j - 1][i - 1] == '#' or x[j - 1][i + 1] == '#' or x[j + 1][i - 1] == '#' or x[j + 1][i + 1] == '#') {
			cout << "NO";
			exit(0);
		}
		if (z[j][i] == 1) {
			i++;
			continue;
		}

		int z1 = 1, z2 = 1;
		z[j][i] = 1;
		for (int i1 = i + 1; i1 < 12; i1++) {
			if (x[j][i1] == '.' or x[j][i1] == '?') break;
			z[j][i1] = 1;
			z1++;
		}
		for (int j1 = j + 1; j1 < 12; j1++) {
			if (x[j1][i] == '.' or x[j1][i] == '?') break;
			z[j1][i] = 1;
			z2++;
		}
		if (z1 > 1 and z2 > 1) {
			cout << "NO";
			exit(0);
		}
		if (max(z1, z2) == 1) x1++;
		if (max(z1, z2) == 2) x2++;
		if (max(z1, z2) == 3) x3++;
		if (max(z1, z2) == 4) x4++;
		i++;
	}
	if (x1 == 4 and x2 == 3 and x3 == 2 and x4 == 1) cout << "YES";
	else cout << "NO";
}