def проверить_расстановку_кораблей(поле):
    размеры_кораблей = [4, 3, 3, 2, 2, 2, 1, 1, 1, 1]

    def проверить_корабль(x, y, размер, вертикально):
        if вертикально:
            for i in range(x, x + размер):
                if поле[i][y] != '#':
                    return False
        else:
            for i in range(y, y + размер):
                if поле[x][i] != '#':
                    return False
        return True

    for размер in размеры_кораблей:
        корабль_найден = False
        for x in range(10):
            for y in range(10):
                if поле[x][y] == '#':
                    continue
                if x + размер <= 10 and проверить_корабль(x, y, размер, True):
                    корабль_найден = True
                    for i in range(x, x + размер):
                        поле[i][y] = '.'
                    break
                if y + размер <= 10 and проверить_корабль(x, y, размер, False):
                    корабль_найден = True
                    for i in range(y, y + размер):
                        поле[x][i] = '.'
                    break
        if not корабль_найден:
            return False

    for x in range(10):
        for y in range(10):
            if поле[x][y] == '#':
                return False

    return True

# Пример использования:
поле = [
    "..........",
    "#....#....#",
    "#........#",
    "#........#",
    "#........#",
    "..........",
    "..........",
    "..........",
    "..........",
    "###.###.##"
]

if проверить_расстановку_кораблей(поле):
    print("Расстановка кораблей корректна.")
else:
    print("Расстановка кораблей некорректна.")

