﻿#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse4,sse4.1,sse4.2,abm,bmi,bmi2,popcnt,lzcnt,avx,avx2,fma")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stack>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <time.h>
#include <deque>
#define ll long long
using namespace std;
using loh = long long; // loh
using flag = bool;
using lohd = long double; // short (4bite) // dolik loh

bool getreality (vector <pair <loh, loh>> coords, bool polyarity, vector <vector <char>>& a) {
	if (polyarity == false) { //vpravo
		for (auto u : coords) {
			if (u.second < 9) {
				if (a[u.first][u.second+1] == '#') {
					return false;
				}
			}
			if (u.second > 0 && a[u.first][u.second - 1] == '#') {
				return false;
			}
		}
		if (coords[0].first > 0) {
			if (a[coords[0].first - 1][coords[0].second] == '#' || (coords[0].second > 0 && a[coords[0].first - 1][coords[0].second - 1] == '#') || (coords[0].second < 9 && a[coords[0].first - 1][coords[0].second + 1] == '#')) {
				return false;
			}
		}
		loh j = coords.size () - 1;
		if (coords[j].first < 9) {
			if (a[coords[j].first + 1][coords[j].second] == '#' || (coords[j].second > 0 && a[coords[j].first + 1][coords[j].second - 1] == '#') || (coords[j].second < 9 && a[coords[j].first + 1][coords[j].second + 1] == '#')) {
				return false;
			}
		}
	}
	else { //vniz
		for (auto u : coords) {
			if (u.first < 9) {
				if (a[u.first + 1][u.second] == '#') {
					return false;
				}
			}
			if (u.first > 0 && a[u.first-1][u.second] == '#') {
				return false;
			}
		}
		if (coords[0].second > 0) {
			if (a[coords[0].first][coords[0].second - 1] == '#' || (coords[0].first > 0 && a[coords[0].first - 1][coords[0].second - 1] == '#') || (coords[0].first < 9 && a[coords[0].first + 1][coords[0].second - 1] == '#')) {
				return false;
			}
		}
		loh j = coords.size () - 1;
		if (coords[j].second < 9) {
			if (a[coords[j].first][coords[j].second + 1] == '#' || (coords[j].first > 0 && a[coords[j].first - 1][coords[j].second + 1] == '#') || (coords[j].first < 9 && a[coords[j].first + 1][coords[j].second + 1] == '#')) {
				return false;
			}
		}
	}
	return true;
}

loh getcount (vector <vector <char>> &a, loh x, loh y) {
	loh fg = 0, size = 1; flag pol = false;
	vector < pair <loh, loh> > coords;
	coords.push_back ({ x, y });
	if (x < 9 && a[x+1][y] == '#') {
		fg = 1;
		a[x][y] = 'x';
		x++;
	}
	else if (y < 9 && a[x][y+1] == '#') {
		fg = -1;
		pol = true;
		y++;
		a[x][y] = 'x';
	}
	if (fg == -1) {
		while (y <= 9 && fg == -1) {
			coords.push_back ({ x, y });
			size++;
			a[x][y] = 'x';
			if (y < 9 && a[x][y + 1] == '#') {
				y++;
			}
			else {
				fg = 0;
			}
		}
	}
	else if (fg == 1) {
		while (x <= 9 && fg == 1) {
			coords.push_back ({ x, y });
			size++;
			a[x][y] = 'x';
			if (x < 9 && a[x+1][y] == '#') {
				x++;
			}
			else {
				fg = 0;
			}
		}
	}
	if (getreality (coords, pol, a)) {
		return size;
	}
	return 100;
}

int main () {
	ios_base::sync_with_stdio (0);
	cin.tie (0);
	cout.tie (0);
	/*
	ll n, m;
	cin >> n >> m;
	ll k = max (n, m);
	ll l = min (n, m);
	if (l == 1) {
		cout << (k-1) * (k + 2) / 2 + k;
		return 0;
	}
	ll sum = k * l * 2 + (k-1)*l*(k+2)/2;
	cout << sum;
	*/
	loh n = 10, count = 0;
	vector <vector <char>> mp (n, vector<char> (n));
	for (loh i = 0; i < n; i++) {
		for (loh y = 0; y < n; y++) {
			cin >> mp[i][y];
			if (mp[i][y] == '#') {
				count++;
			}
		}
	} // 4 + 6 + 8 + 4
	if (count != 20) {
		cout << "NO";
		return 0;
	}
	vector <loh> p = { 4, 3, 2, 1 };
	for (loh i = 0; i < n; i++) {
		for (loh y = 0; y < n; y++) {
			if (mp[i][y] == '#') {
				loh sizz = getcount (mp, i, y);
				if (sizz > 4) {
					cout << "NO";
					return 0;
				}
				p[sizz-1]--;
			}
		}
	}
	for (loh i = 0; i < 4; i++) {
		if (p[i] != 0) {
			cout << "NO";
			return 0;
		}
	}
	cout << "YES";
}