def find_kth_task(n, q, k, permutation, segments):
    tasks = list(range(1, n+1))  # Инициализация списка дел

    for l, r in segments:
        # Изменение порядка выполнения дел
        tasks[l-1:r] = sorted(tasks[l-1:r], key=lambda task: permutation.index(task))
  
    return tasks[k-1]

# Получение входных данных
n, q, k = map(int, input().split())
permutation = list(map(int, input().split()))

segments = []
for _ in range(q):
    l, r = map(int, input().split())
    segments.append((l, r))

# Вызов функции для поиска номера дела k
kth_task = find_kth_task(n, q, k, permutation, segments)
print(kth_task)
