
def check_battleship_field(field):
    # Проверка, что на поле присутствуют все 10 кораблей
    if field.count('#') != 10:
        return 'NO'

    # Проверка, что каждый корабль целиком помещается внутрь поля и образует прямоугольник
    for row in range(10):
        for col in range(10):
            if field[row][col] == '#':
                # Проверка, что корабль целиком помещается внутрь поля
                if row + 4 <= 10 and all(field[r][col] == '#' for r in range(row, row+4)):
                    for r in range(row, row+4):
                        field[r][col] = '.'  # помечаем уже проверенные клетки
                elif col + 4 <= 10 and all(field[row][c] == '#' for c in range(col, col+4)):
                    for c in range(col, col+4):
                        field[row][c] = '.'  # помечаем уже проверенные клетки
                elif row + 3 <= 10 and all(field[r][col] == '#' for r in range(row, row+3)):
                    for r in range(row, row+3):
                        field[r][col] = '.'  # помечаем уже проверенные клетки
                elif col + 3 <= 10 and all(field[row][c] == '#' for c in range(col, col+3)):
                    for c in range(col, col+3):
                        field[row][c] = '.'  # помечаем уже проверенные клетки
                elif row + 2 <= 10 and all(field[r][col] == '#' for r in range(row, row+2)):
                    for r in range(row, row+2):
                        field[r][col] = '.'  # помечаем уже проверенные клетки
                elif col + 2 <= 10 and all(field[row][c] == '#' for c in range(col, col+2)):
                    for c in range(col, col+2):
                        field[row][c] = '.'  # помечаем уже проверенные клетки
                elif field[row][col] == '#':
                    return 'NO'  # корабль не образует прямоугольник
                

    # Проверка, что каждый корабль расположен либо вертикально, либо горизонтально
    for row in range(10):
        for col in range(10):
            if field[row][col] == '#':
                if row+1 < 10 and field[row+1][col] == '#':
                    return 'NO'  # корабли касаются друг друга по вертикали
                if col+1 < 10 and field[row][col+1] == '#':
                    return 'NO'  # корабли касаются друг друга по горизонтали

    return 'YES'  # поле соответствует корректной расстановке кораблей
               
               
# Пример использования
field = []
for _ in range(
